﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;


public class WeaponShopButton : MonoBehaviour {

    public PlayerStats stats; // to set the weapon
    public int weaponNumber;
    public Text wepName;
    public Text description;
    public Text cost;
    public Image imageDisplay;
	private WeaponStats[] weapons; // to get access to weapon array
    public Money money; // to access and manipulate coin amount

    // Use this for initialization
    void Start () {
        //money = GameObject.Find("Coins").GetComponent<Money>();
		stats = GameObject.Find ("Player").GetComponent<PlayerStats> ();
		weapons = GameObject.Find("Canvas").GetComponent<WeaponList>().weapons;
        setButton();
	}
	
	// Update is called once per frame
	void Update () {
	
	}

    // created by following the 'Creating An In-Game Shop' shop tutorial on unity3d.com
    // dynamically allocates the shop buttons based on created weapons
    void setButton() {
        string costToString = weapons[weaponNumber].cost.ToString(); // convert float to string
        wepName.text = weapons[weaponNumber].weaponName;
        description.text = weapons[weaponNumber].weaponDescription;
        cost.text = costToString;
        imageDisplay.sprite = weapons[weaponNumber].image;
    }

    public void OnClick() {
        
        int price = weapons[weaponNumber].cost;
        // buying the weapons based on currency
        if (money.getMoney() >= price && cost.text != "PURCHASED") {
            money.decreaseCoins(price);
            stats.setWeapon(weapons[weaponNumber]);
            cost.text = "PURCHASED";
        }
        else {
            // will implement sound/visual that the player cannot afford here
        }
       

    }

    // to display weapon stats when you hover over a weapon
    public void HoverEnter() {
        description.text = "Damage:\n" + weapons[weaponNumber].damageMin.ToString() + " - " 
            + weapons[weaponNumber].damageMax.ToString() + "\n\n" + "Attack Speed:\n" 
            + weapons[weaponNumber].attackSpeed.ToString();
    }

    // to revert back to the original description
    public void HoverExit() {
        description.text = weapons[weaponNumber].weaponDescription;
    }
}
